package acceptor;
import java.util.Hashtable;

import org.robotservices.v02.profile.invoker.IMultimedia_profile;
public class CameraSessionManager {

	private static CameraSessionManager own = new CameraSessionManager();
	//コールバッククラスを保存id(key),callback(value)
	private Hashtable<String, CameraCallback> callbacktable = new Hashtable<String, CameraCallback>();
	//
	private Hashtable<String, String> distributionidtable = new Hashtable<String, String>();
	private Hashtable<String, IMultimedia_profile> mptable = new Hashtable<String, IMultimedia_profile>();
	private Hashtable<String, String> commissioning_status = new Hashtable<String,String>();
	private Hashtable<String, byte[]> camera_picture = new Hashtable<String,byte[]>();
	CameraSessionManager(){

	}

	public static CameraSessionManager getInstance() {
		return own;
	}
	public void setDistributionId(String id, String distribution_id_str) {
		distributionidtable.put(id, distribution_id_str);
	}
	public String getDistributionId(String id) {
		return distributionidtable.get(id);
	}
	public void setCallback(String id, CameraCallback callback) {
		callbacktable.put(id, callback);
	}
	public CameraCallback getCallback(String id) {
		return callbacktable.get(id);
	}
	public void releaseCallback(String id){
		callbacktable.remove(id);
	}
	public void setMultimediaProfile(String id,IMultimedia_profile mp) {
		mptable.put(id, mp);
	}
	public IMultimedia_profile getMultimediaProfile(String id) {
		return mptable.get(id);
	}
	public void releaseMultimedia_profile(String id){
		mptable.remove(id);
	}

	public void set_commissioning_status(String id,String status){
		commissioning_status.put(id, status);
	}

	public String get_commissioning_status(String id){
		return commissioning_status.get(id);
	}

	public void set_camera_picture(String id,byte[] pic){
		camera_picture.put(id, pic);
	}
	public byte[] get_camera_picture(String id){
		return camera_picture.get(id);
	}
}
