package acceptor;

import java.util.Hashtable;

import org.robotservices.v02.profile.invoker.IMultimedia_profile;



@SuppressWarnings("unused")

public class SensorSessionManager {
	private static SensorSessionManager own = new SensorSessionManager();

	private Hashtable<String, SensorCallback> callbacktable = new Hashtable<String, SensorCallback>();
	private Hashtable<String, String> distributionidtable = new Hashtable<String, String>();
	private Hashtable<String, IMultimedia_profile> mptable = new Hashtable<String, IMultimedia_profile>();
	private Hashtable<String, String> commissioning_status = new Hashtable<String,String>();
	private Hashtable<String, String> sensor_record = new Hashtable<String,String>();
	SensorSessionManager(){

	}

	public static SensorSessionManager getInstance() {
		return own;
	}
	public void setDistributionId(String id, String distribution_id_str) {
		distributionidtable.put(id, distribution_id_str);
	}
	public String getDistributionId(String id) {
		return distributionidtable.get(id);
	}
	public void setCallback(String id, SensorCallback callback) {
		callbacktable.put(id, callback);
	}
	public SensorCallback getCallback(String id) {
		return callbacktable.get(id);
	}
	public void releaseCallback(String id){
		callbacktable.remove(id);
	}
	public void setMultimediaProfile(String id,IMultimedia_profile mp) {
		mptable.put(id, mp);
	}
	public IMultimedia_profile getMultimediaProfile(String id) {
		return mptable.get(id);
	}

	public void set_sensor_data(String id,String sensor){
		sensor_record.put(id, sensor);
	}
	public String get_sensor_data(String id){
		return sensor_record.get(id);
	}
}

