<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8"%>
<%@page import="acceptor.RobotWorkerManager"%>
<%@page import="java.util.Enumeration"%>
<%@page import="java.util.ArrayList"%>
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<title>Camera</title>

<style type="text/css">

body {
background:#FFFFCC;
}

#robot_display {
width:300px;
height:400px;
z-index: 0;
}

#image {
border:solid 1px #ccc;
width:480px;
height:360px;
z-index: 1;
}
</style>

</head>
<script type="text/javascript" src="./js/jquery-2.1.1.min.js"></script>
<script>

var timer = null;
var interval = 1000;
var select_id = "";
$(function(){
	 $("#distribute_time").val(interval);
	//配信開始ボタン
	if(!timer) {
		timer = setInterval(execIntervalFunc, interval);
	}
	$("#distribute_start").click(function(){
		if(!timer) {
			timer = setInterval(execIntervalFunc, interval);
		}
	});
	//配信停止ボタン
	$("#distribute_stop").click(function(){
		clearIntervalFunc();
		count = 0;
	});

	$("#distribute_time").change(function(){
		clearIntervalFunc();
		interval = $(this).val();
		console.log(interval);
		timer= null;
		if(!timer) {
			timer = setInterval(execIntervalFunc, interval);
		}
	}).change();

	$("#robot_ids").change(function(){
		select_id = $(this).val();
	}).change();
});

//繰り返し関数
function execIntervalFunc() {
	//画像受信処理
	var id = select_id;
	if(id != null && id != ""){
		//クエリ文字列
		var date = new Date();
		var request = "robot_id="+id+"&mode=display&interval="+interval+"&time="+date.getTime();
		var req = "./camera?"+request;
		$("#image").attr("src",req);
		}
	}

function clearIntervalFunc() {
	// setIntervalの停止
	clearInterval(timer);
	timer = null;
	var id = select_id;
	if(id != null && id != ""){
		//クエリ文字列
		var date = new Date();
		var request = "robot_id="+id+"&mode=stop&interval="+interval+"&time="+date.getTime();
		var req = "./camera?"+request;
		$("#image").attr("src",req);
		}
}



</script>
<body>

<%
	ArrayList <String> robot_ids = new ArrayList<String>();
	RobotWorkerManager rwm = RobotWorkerManager.getInstance();
	Enumeration<String> en = rwm.getRobotIds();
%>
ロボットID：<select id = "robot_ids" size="1">
<%
	while (en.hasMoreElements()) {
		String rid = en.nextElement();
%>
<option value = "<%= rid %>"><%= rid %></option>
<%
	}
%>
</select>
<br>
<img src="" id="image" width="480" height="360"></img>
<br>
<button id="distribute_start">カメラ配信</button>
<button id="distribute_stop">配信停止</button>
<select id="distribute_time">
<option value="10000">0.1</option>
<option value="2000">0.5</option>
<option value="1000">1</option>
<option value="500">2</option>
<option value="300">3</option>
<option value="250">4</option>
<option value="200">5</option>
<option value="180">6</option>
<option value="140">7</option>
<option value="125">8</option>
<option value="110">9</option>
<option value="100">10</option>
</select>枚/s

<%
//セッションidとランダム文字列を使い分ける

%>

</body>
