package manager;

import java.util.ArrayList;
import java.util.Hashtable;


public class ApriPocoManager{

	private static ApriPocoManager own = new ApriPocoManager();
	private Hashtable<String,Pocodatas> poco_table = new Hashtable<String,Pocodatas>();
	private ArrayList<String> poco_ids = new ArrayList<String>();
	private ApriPocoManager(){

	}

	public static ApriPocoManager getInstance(){
		return own;
	}

	public void set_Pocodata(String robotid,String data){
		if(poco_table.get(robotid)==null){
			System.out.println("new Pocodatas");
			poco_table.put(robotid, new Pocodatas());
			poco_ids.add(robotid);
		}
		//System.out.println("robotid:"+robotid+",data:"+data);
		Pocodatas poco = poco_table.get(robotid);
		poco.set_data(data);
	}

	public String get_Pocodatas(){
		String pocodatas = "";
		for(int i=0;i<poco_ids.size();i++){
			pocodatas += poco_table.get(poco_ids.get(i)).get_data();
		}
		return pocodatas;
	}

	class Pocodatas{
		String poco_data = "";
		synchronized void set_data(String data){
			poco_data = data;
		}

		synchronized String get_data(){
			return poco_data;
		}
	}

}
